<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_tableName'] =  'civicrm_acl_entity_role';
$GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_fields'] =  null;
$GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_links'] =  null;
$GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_import'] =  null;
$GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_export'] =  null;
$GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_ACL_DAO_EntityRole extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Unique table ID
     *
     * @var int unsigned
     */
    var $id;
    /**
     * Which Domain owns this contact
     *
     * @var int unsigned
     */
    var $domain_id;
    /**
     * Foreign Key to ACL Role (which is an option value pair and hence an implicit FK)
     *
     * @var int unsigned
     */
    var $acl_role_id;
    /**
     * Table of the object joined to the ACL Role (Contact or Group)
     *
     * @var string
     */
    var $entity_table;
    /**
     * ID of the group/contact object being joined
     *
     * @var int unsigned
     */
    var $entity_id;
    /**
     * Is this property active?
     *
     * @var boolean
     */
    var $is_active;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_acl_entity_role
     */
    function CRM_ACL_DAO_EntityRole() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_links'])) {
            $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_links'] = array(
                'domain_id' => 'civicrm_domain:id',
            );
        }
        return $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_fields'])) {
            $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'domain_id' => array(
                    'name' => 'domain_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'acl_role_id' => array(
                    'name' => 'acl_role_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'entity_table' => array(
                    'name' => 'entity_table',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Entity Table') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'entity_id' => array(
                    'name' => 'entity_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'is_active' => array(
                    'name' => 'is_active',
                    'type' => CRM_UTILS_TYPE_T_BOOLEAN,
                ) ,
            );
        }
        return $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_import'])) {
            $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_import'] = array();
            $fields = &CRM_ACL_DAO_EntityRole::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_import']['acl_entity_role'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_export'])) {
            $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_export'] = array();
            $fields = &CRM_ACL_DAO_EntityRole::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_export']['acl_entity_role'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_ACL_DAO_ENTITYROLE']['_export'];
    }
}
?>