<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_DAO_LINEITEM']['_tableName'] =  'civicrm_line_item';
$GLOBALS['_CRM_CORE_DAO_LINEITEM']['_fields'] =  null;
$GLOBALS['_CRM_CORE_DAO_LINEITEM']['_links'] =  null;
$GLOBALS['_CRM_CORE_DAO_LINEITEM']['_import'] =  null;
$GLOBALS['_CRM_CORE_DAO_LINEITEM']['_export'] =  null;
$GLOBALS['_CRM_CORE_DAO_LINEITEM']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Core_DAO_LineItem extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Line Item
     *
     * @var int unsigned
     */
    var $id;
    /**
     * table which has the transaction
     *
     * @var string
     */
    var $entity_table;
    /**
     * entry in table
     *
     * @var int unsigned
     */
    var $entity_id;
    /**
     * FK to price_field
     *
     * @var int unsigned
     */
    var $price_field_id;
    /**
     * FK to custom_option
     *
     * @var int unsigned
     */
    var $custom_option_id;
    /**
     * descriptive label for item - from custom_option.label
     *
     * @var string
     */
    var $label;
    /**
     * How many items ordered
     *
     * @var int unsigned
     */
    var $qty;
    /**
     * price of each item
     *
     * @var float
     */
    var $unit_price;
    /**
     * qty * unit_price
     *
     * @var float
     */
    var $line_total;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_line_item
     */
    function CRM_Core_DAO_LineItem() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_LINEITEM']['_links'])) {
            $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_links'] = array(
                'price_field_id' => 'civicrm_price_field:id',
                'custom_option_id' => 'civicrm_custom_option:id',
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_LINEITEM']['_fields'])) {
            $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'entity_table' => array(
                    'name' => 'entity_table',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Entity Table') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'entity_id' => array(
                    'name' => 'entity_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'price_field_id' => array(
                    'name' => 'price_field_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'custom_option_id' => array(
                    'name' => 'custom_option_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'label' => array(
                    'name' => 'label',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Label') ,
                    'required' => true,
                    'maxlength' => 255,
                    'size' => CRM_UTILS_TYPE_HUGE,
                ) ,
                'qty' => array(
                    'name' => 'qty',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Qty') ,
                    'required' => true,
                ) ,
                'unit_price' => array(
                    'name' => 'unit_price',
                    'type' => CRM_UTILS_TYPE_T_MONEY,
                    'title' => ts('Unit Price') ,
                    'required' => true,
                ) ,
                'line_total' => array(
                    'name' => 'line_total',
                    'type' => CRM_UTILS_TYPE_T_MONEY,
                    'title' => ts('Line Total') ,
                    'required' => true,
                ) ,
            );
        }
        return $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_LINEITEM']['_import'])) {
            $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_import'] = array();
            $fields = &CRM_Core_DAO_LineItem::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_import']['line_item'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_CORE_DAO_LINEITEM']['_export'])) {
            $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_export'] = array();
            $fields = &CRM_Core_DAO_LineItem::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_export']['line_item'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_CORE_DAO_LINEITEM']['_export'];
    }
}
?>