<?php
/*
+--------------------------------------------------------------------+
| CiviCRM version 1.8                                                |
+--------------------------------------------------------------------+
| Copyright CiviCRM LLC (c) 2004-2007                                |
+--------------------------------------------------------------------+
| This file is a part of CiviCRM.                                    |
|                                                                    |
| CiviCRM is free software; you can copy, modify, and distribute it  |
| under the terms of the Affero General Public License Version 1,    |
| March 2002.                                                        |
|                                                                    |
| CiviCRM is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
| See the Affero General Public License for more details.            |
|                                                                    |
| You should have received a copy of the Affero General Public       |
| License along with this program; if not, contact CiviCRM LLC       |
| at info[AT]civicrm[DOT]org.  If you have questions about the       |
| Affero General Public License or the licensing  of CiviCRM,        |
| see the CiviCRM license FAQ at http://civicrm.org/licensing        |
+--------------------------------------------------------------------+
*/
/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_DEDUPE_DAO_RULE']['_tableName'] =  'civicrm_dedupe_rule';
$GLOBALS['_CRM_DEDUPE_DAO_RULE']['_fields'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULE']['_links'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULE']['_import'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULE']['_export'] =  null;
$GLOBALS['_CRM_DEDUPE_DAO_RULE']['_log'] =  false;

require_once 'CRM/Core/DAO.php';
require_once 'CRM/Utils/Type.php';
class CRM_Dedupe_DAO_Rule extends CRM_Core_DAO
{
    /**
     * static instance to hold the table name
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the field values
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the FK relationships
     *
     * @var string
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be imported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static instance to hold the values that can
     * be exported / apu
     *
     * @var array
     * @static
     */
    
    /**
     * static value to see if we should log any modifications to
     * this table in the civicrm_log table
     *
     * @var boolean
     * @static
     */
    
    /**
     * Unique dedupe rule id
     *
     * @var int unsigned
     */
    var $id;
    /**
     * The id of the rule group this rule belongs to
     *
     * @var int unsigned
     */
    var $dedupe_rule_group_id;
    /**
     * The name of the table this rule is about
     *
     * @var string
     */
    var $rule_table;
    /**
     * The name of the field of the table referenced in rule_table
     *
     * @var string
     */
    var $rule_field;
    /**
     * The lenght of the matching substring
     *
     * @var int unsigned
     */
    var $rule_length;
    /**
     * The weight of the rule
     *
     * @var int
     */
    var $rule_weight;
    /**
     * class constructor
     *
     * @access public
     * @return civicrm_dedupe_rule
     */
    function CRM_Dedupe_DAO_Rule() 
    {
        parent::CRM_Core_DAO();
    }
    /**
     * return foreign links
     *
     * @access public
     * @return array
     */
    function &links() 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULE']['_links'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_links'] = array(
                'dedupe_rule_group_id' => 'civicrm_dedupe_rule_group:id',
            );
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_links'];
    }
    /**
     * returns all the column names of this table
     *
     * @access public
     * @return array
     */
    function &fields() 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULE']['_fields'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_fields'] = array(
                'id' => array(
                    'name' => 'id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'dedupe_rule_group_id' => array(
                    'name' => 'dedupe_rule_group_id',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'required' => true,
                ) ,
                'rule_table' => array(
                    'name' => 'rule_table',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Rule Table') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'rule_field' => array(
                    'name' => 'rule_field',
                    'type' => CRM_UTILS_TYPE_T_STRING,
                    'title' => ts('Rule Field') ,
                    'required' => true,
                    'maxlength' => 64,
                    'size' => CRM_UTILS_TYPE_BIG,
                ) ,
                'rule_length' => array(
                    'name' => 'rule_length',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Rule Length') ,
                ) ,
                'rule_weight' => array(
                    'name' => 'rule_weight',
                    'type' => CRM_UTILS_TYPE_T_INT,
                    'title' => ts('Rule Weight') ,
                    'required' => true,
                ) ,
            );
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_fields'];
    }
    /**
     * returns the names of this table
     *
     * @access public
     * @return string
     */
    function getTableName() 
    {
        return $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_tableName'];
    }
    /**
     * returns if this table needs to be logged
     *
     * @access public
     * @return boolean
     */
    function getLog() 
    {
        return $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_log'];
    }
    /**
     * returns the list of fields that can be imported
     *
     * @access public
     * return array
     */
    function &import($prefix = false) 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULE']['_import'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_import'] = array();
            $fields = &CRM_Dedupe_DAO_Rule::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('import', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_import']['dedupe_rule'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_import'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_import'];
    }
    /**
     * returns the list of fields that can be exported
     *
     * @access public
     * return array
     */
    function &export($prefix = false) 
    {
        if (!($GLOBALS['_CRM_DEDUPE_DAO_RULE']['_export'])) {
            $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_export'] = array();
            $fields = &CRM_Dedupe_DAO_Rule::fields();
            foreach($fields as $name => $field) {
                if (CRM_Utils_Array::value('export', $field)) {
                    if ($prefix) {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_export']['dedupe_rule'] = &$fields[$name];
                    } else {
                        $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_export'][$name] = &$fields[$name];
                    }
                }
            }
        }
        return $GLOBALS['_CRM_DEDUPE_DAO_RULE']['_export'];
    }
}
?>