<?php

/*
 +--------------------------------------------------------------------+
 | CiviCRM version 1.8                                                |
 +--------------------------------------------------------------------+
 | Copyright CiviCRM LLC (c) 2004-2007                                |
 +--------------------------------------------------------------------+
 | This file is a part of CiviCRM.                                    |
 |                                                                    |
 | CiviCRM is free software; you can copy, modify, and distribute it  |
 | under the terms of the Affero General Public License Version 1,    |
 | March 2002.                                                        |
 |                                                                    |
 | CiviCRM is distributed in the hope that it will be useful, but     |
 | WITHOUT ANY WARRANTY; without even the implied warranty of         |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
 | See the Affero General Public License for more details.            |
 |                                                                    |
 | You should have received a copy of the Affero General Public       |
 | License along with this program; if not, contact CiviCRM LLC       |
 | at info[AT]civicrm[DOT]org.  If you have questions about the       |
 | Affero General Public License or the licensing  of CiviCRM,        |
 | see the CiviCRM license FAQ at http://civicrm.org/licensing        |
 +--------------------------------------------------------------------+
*/

/**
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */

/**
 * class to represent the actions that can be performed on a group of contacts
 * used by the search forms
 *
 */
define( 'CRM_EVENT_TASK_DELETE_EVENTS',1);
define( 'CRM_EVENT_TASK_PRINT_EVENTS',2);
define( 'CRM_EVENT_TASK_EXPORT_EVENTS',3);
define( 'CRM_EVENT_TASK_BATCH_EVENTS',4);
define( 'CRM_EVENT_TASK_CANCEL_REGISTRATION',5);
define( 'CRM_EVENT_TASK_EMAIL_CONTACTS',6);
define( 'CRM_EVENT_TASK_SAVE_SEARCH',13);
define( 'CRM_EVENT_TASK_SAVE_SEARCH_UPDATE',14);
$GLOBALS['_CRM_EVENT_TASK']['_tasks'] =  null;
$GLOBALS['_CRM_EVENT_TASK']['_optionalTasks'] =  null;

class CRM_Event_Task
{
    
                                  
                                   
                                  
                                   
                            
                                 
        // Value for SAVE_SEARCH is set as 13 in accordance with CRM_Contact_Task::SAVE_SEARCH
                                    
                             

    /**
     * the task array
     *
     * @var array
     * @static
     */
    

    /**
     * the optional task array
     *
     * @var array
     * @static
     */
    

    /**
     * These tasks are the core set of tasks that the user can perform
     * on a contact / group of contacts
     *
     * @return array the set of tasks for a group of contacts
     * @static
     * @access public
     */
     function &tasks()
    {
        if (!($GLOBALS['_CRM_EVENT_TASK']['_tasks'])) {
            $GLOBALS['_CRM_EVENT_TASK']['_tasks'] = array(
                                  1     => ts( 'Delete Participants'                   ),
                                  3     => ts( 'Export Participants'                   ),
                                  4     => ts( 'Batch Update Participants Via Profile' ),
                                  5     => ts( 'Cancel Registration'                   ),
                                  13    => ts( 'New Smart Group'                       ),
                                  6     => ts( 'Send Email to Contacts'                ), 
                                  );
        }

        asort($GLOBALS['_CRM_EVENT_TASK']['_tasks']);        
        return $GLOBALS['_CRM_EVENT_TASK']['_tasks'];
    }

    /**
     * These tasks get added based on the context the user is in
     *
     * @return array the set of optional tasks for a group of contacts
     * @static
     * @access public
     */
     function &optionalTaskTitle()
    {
        $tasks = array(
                       14    => ts( 'Update Smart Group')
                       );
        return $tasks;
    }

}
?>